#include "util.h"

char *
SQZMV (to, from, size)
char *to, *from;
int size;
{
	memcpy (to, from, (unsigned)size);
	to += size;
	return (to);
}


char *
SQZ (to, from, maxsz)
char *to, *from;
int maxsz;
{
int size;

	size = strlen (from);
	if (maxsz < size)
		size = maxsz;
	*to++ = size;
	return (SQZMV (to, from, size));
}


int 
squeeze (ap, bf)
struct appl_dat *ap;
char *bf;
{
long tmplong;
char buff[10];
char *cp = bf;

	cp = SQZ (cp, ap->name_licensee, 40);
	cp = SQZ (cp, ap->text_street, 35);
	cp = SQZ (cp, ap->text_pobox, 20);
	cp = SQZ (cp, ap->city, 20);
	cp = SQZMV (cp, ap->state, 2);

	strncpy (buff, ap->zipcode, 9);
	buff[9] = 0;
	tmplong = atol (buff);
	cp = SQZMV (cp, (char *) &tmplong, sizeof (long));
	cp = SQZMV (cp, (char *) &ap->date_of_birth, sizeof (time_t));
	cp = SQZMV (cp, (char *) &ap->date_issue, sizeof (time_t));
	cp = SQZMV (cp, (char *) &ap->date_expire, sizeof (time_t));
	cp = SQZMV (cp, (char *) &ap->date_last_change, sizeof (time_t));

	*cp++ = ap->type_op_class;
	*cp++ = ap->type_prev_op_class;
	cp = SQZ(cp, ap->callsign_prev, 10);
	return (cp - bf);
}



char *
USQZMV (from, to, size)
char *to, *from;
int size;
{
	memcpy (to, from, (unsigned)size);
	from += size;
	return (from);
}


char *
USQZ (from, to, maxsz)
char *to, *from;
int maxsz;
{
int size;
char *retval;

	size = *from++;
	retval = USQZMV (from, to, size);
	if (maxsz != size)
		to[size] = 0;
	return retval;
}


int 
unsqueeze (ap, bf)
struct appl_dat *ap;
char *bf;
{
long tmplong;
char *cp = bf, *ptr;

	cp = USQZ (cp, ap->name_licensee, 40);
	cp = USQZ (cp, ap->text_street, 35);
	cp = USQZ (cp, ap->text_pobox, 20);
	cp = USQZ (cp, ap->city, 20);
	cp = USQZMV (cp, ap->state, 2);

	cp = USQZMV (cp, (char *) &tmplong, sizeof (long));
	sprintf (ap->zipcode, "%05ld", tmplong);
	if ((ptr = strchr (ap->zipcode, ' ')) != NULLCHAR)
		*ptr = 0;

	cp = USQZMV (cp, (char *) &ap->date_of_birth, sizeof (time_t));
	cp = USQZMV (cp, (char *) &ap->date_issue, sizeof (time_t));
	cp = USQZMV (cp, (char *) &ap->date_expire, sizeof (time_t));
	cp = USQZMV (cp, (char *) &ap->date_last_change, sizeof (time_t));

	ap->type_op_class = *cp++;
	ap->type_prev_op_class = *cp++;
	cp = USQZ(cp, ap->callsign_prev, 10);
	return (cp - bf);
}




